#!/usr/bin/env python

import sys
import gtk
import GtkExtra

class ISgui:

	def start_button(self, *args):
		command1 = "/etc/init.d/ipaq-sleep stop;/usr/bin/ipaq-sleep -S"
		if self.AScheckbutton.get_active() == gtk.TRUE:
			u = self.ASspinbutton.get_value_as_int()
			command1 = str(command1) + " -u " + str(u)
		else:
			command1 = str(command1) + " -u 0"
		if self.ADcheckbutton.get_active() == gtk.TRUE:
			o = self.ADspinbutton.get_value_as_int()
			command1 = str(command1) + " -o " + str(o)
		else:
			command1 = str(command1) + " -o 0"
		if self.apmcheckbutton.get_active() == gtk.FALSE:
			command1 = str(command1) + " -a "
		if self.probecheckbutton.get_active() == gtk.FALSE:
			command1 = str(command1) + " -p "
		if self.cpucheckbutton.get_active() == gtk.TRUE:
			C = self.cpuspinbutton.get_value_as_float()
			command1 = str(command1) + " -C " + str(C)
		else:
			command1 = str(command1) + " -c"
		command2 = "/etc/init.d/ipaq-sleep start"
		os.system(command1)
		os.system(command2)

	def stop_button(self, *args):
		command = "/etc/init.d/ipaq-sleep stop"
		os.system(command)

	def bl_vscale_changed(self, *args):
        	power = self.bl_adjust.value
        	if power <= 1:
            		os.system("bl 1 0 0")
        	else:
            		os.system("bl 1 1 " + str(power))
		return gtk.FALSE
		
	def cpu_checked(self, *args):
		if self.cpucheckbutton.get_active() == gtk.TRUE:
			self.cpuspinbutton.set_sensitive(gtk.TRUE)
		else:
			self.cpuspinbutton.set_sensitive(gtk.FALSE)
		return gtk.FALSE
			
    	def AD_checked(self, *args):
		if self.ADcheckbutton.get_active() == gtk.TRUE:
			self.ADspinbutton.set_sensitive(gtk.TRUE)
		else:
			self.ADspinbutton.set_sensitive(gtk.FALSE)
		return gtk.FALSE
			
    	def AS_checked(self, *args):
		if self.AScheckbutton.get_active() == gtk.TRUE:
			self.ASspinbutton.set_sensitive(gtk.TRUE)
		else:
			self.ASspinbutton.set_sensitive(gtk.FALSE)
		return gtk.FALSE
			
    	def __init__(self):
    
		# make a window
		self.window=gtk.GtkWindow(gtk.WINDOW_TOPLEVEL)
		self.window.connect("delete_event", self.quit)
		self.window.set_title("ISgui v0.1")
		self.window.set_usize(240, 220)
		
		# Main vBox
		self.vbox = gtk.GtkVBox()
		self.window.add(self.vbox)
		self.vbox.show()

		# top hbox for Auto-sleep and Auto-dim frames
		self.tophbox=gtk.GtkHBox()
		self.vbox.pack_start(self.tophbox, gtk.TRUE, gtk.TRUE, 0)
		self.tophbox.show()
		
		# Auto-sleep frame
		self.ASframe=gtk.GtkFrame()
		self.tophbox.pack_start(self.ASframe, gtk.TRUE, gtk.TRUE, 0)
		self.ASframe.set_shadow_type(gtk.SHADOW_ETCHED_IN)
		self.ASframe.set_label("Auto-sleep")
		self.ASframe.show()
		
		# Auto-sleep frame vbox
		self.ASvbox=gtk.GtkVBox()
		self.ASframe.add(self.ASvbox)
		self.ASvbox.show()
		
		self.AScheckbutton=gtk.GtkCheckButton("enabled")
		self.ASvbox.pack_start(self.AScheckbutton, gtk.FALSE, gtk.FALSE, 0)
		self.AScheckbutton.set_active(gtk.TRUE)
		self.AScheckbutton.connect("toggled", self.AS_checked)
		self.AScheckbutton.show()

		# small hbox for Auto-sleep idle time
		self.ASidlehbox=gtk.GtkHBox()
		self.ASvbox.pack_start(self.ASidlehbox, gtk.TRUE, gtk.TRUE, 0)
		self.ASidlehbox.show()
		
		self.ASspinbutton_adjust=gtk.GtkAdjustment(180, 5, 1800, 5, 10, 10)
        	self.ASspinbutton=gtk.GtkSpinButton(self.ASspinbutton_adjust, 1, 0)
		self.ASidlehbox.pack_start(self.ASspinbutton, gtk.FALSE, gtk.FALSE, 0)
		self.ASspinbutton.set_usize(50, 20)
		self.ASspinbutton.show()

		self.ASspinlabel=gtk.GtkLabel()
        	self.ASidlehbox.pack_start(self.ASspinlabel, gtk.FALSE, gtk.FALSE, 0)
		self.ASspinlabel.set_text("idle (s)")
		self.ASspinlabel.show()
        
		# Auto-dim frame
		self.ADframe=gtk.GtkFrame()
		self.tophbox.pack_start(self.ADframe, gtk.TRUE, gtk.TRUE, 0)
		self.ADframe.set_shadow_type(gtk.SHADOW_ETCHED_IN)
		self.ADframe.set_label("Auto-dim")
		self.ADframe.show()
		
		# Auto-dim frame vbox
		self.ADvbox=gtk.GtkVBox()
		self.ADframe.add(self.ADvbox)
		self.ADvbox.show()
		
		self.ADcheckbutton=gtk.GtkCheckButton("enabled")
		self.ADvbox.pack_start(self.ADcheckbutton, gtk.FALSE, gtk.FALSE, 0)
		self.ADcheckbutton.set_active(gtk.TRUE)
		self.ADcheckbutton.connect("toggled", self.AD_checked)
		self.ADcheckbutton.show()

		# small hbox for Auto-sleep idle time
		self.ADidlehbox=gtk.GtkHBox()
		self.ADvbox.pack_start(self.ADidlehbox, gtk.TRUE, gtk.TRUE, 0)
		self.ADidlehbox.show()
		
		self.ADspinbutton_adjust=gtk.GtkAdjustment(60, 5, 1800, 5, 10, 10)
        	self.ADspinbutton=gtk.GtkSpinButton(self.ADspinbutton_adjust, 1, 0)
		self.ADidlehbox.pack_start(self.ADspinbutton, gtk.FALSE, gtk.FALSE, 0)
		self.ADspinbutton.show()

		self.ADspinlabel=gtk.GtkLabel()
        	self.ADidlehbox.pack_start(self.ADspinlabel, gtk.FALSE, gtk.FALSE, 0)
		self.ADspinlabel.set_text("idle (s)")
		self.ADspinbutton.set_usize(50, 20)
		self.ADspinlabel.show()
		
		# mid hbox for Sleep options and Backlight value frames
		self.midhbox=gtk.GtkHBox()
		self.vbox.pack_start(self.midhbox, gtk.TRUE, gtk.TRUE, 0)
		self.midhbox.show()
		
		# Sleep options frame
		self.SOframe=gtk.GtkFrame()
		self.midhbox.pack_start(self.SOframe, gtk.TRUE, gtk.TRUE, 0)
		self.SOframe.set_shadow_type(gtk.SHADOW_ETCHED_IN)
		self.SOframe.set_label("Auto-sleep")
		self.SOframe.show()
		
		# Sleep options frame vbox
		self.SOvbox=gtk.GtkVBox()
		self.SOframe.add(self.SOvbox)
		self.SOvbox.show()
		
		self.apmcheckbutton=gtk.GtkCheckButton("apm")
		self.SOvbox.pack_start(self.apmcheckbutton, gtk.FALSE, gtk.FALSE, 0)
		self.apmcheckbutton.set_active(gtk.TRUE)
		self.apmcheckbutton.show()

		# cpu hbox w/in Sleep options frame
		self.SOcpuhbox=gtk.GtkHBox()
		self.SOvbox.pack_start(self.SOcpuhbox, gtk.FALSE, gtk.FALSE, 0)
		self.SOcpuhbox.show()
		
		self.cpucheckbutton=gtk.GtkCheckButton("cpu")
		self.SOcpuhbox.pack_start(self.cpucheckbutton, gtk.FALSE, gtk.FALSE, 0)
		self.cpucheckbutton.set_active(gtk.TRUE)
		self.cpucheckbutton.connect("toggled", self.cpu_checked)
		self.cpucheckbutton.show()

		self.cpuspinbutton_adjust=gtk.GtkAdjustment(0.05, 0.01, 2.00, 0.01, 0.05, 10)
        	self.cpuspinbutton=gtk.GtkSpinButton(self.cpuspinbutton_adjust, 1, 2)
		self.SOcpuhbox.pack_start(self.cpuspinbutton, gtk.FALSE, gtk.FALSE, 0)
		self.cpuspinbutton.set_sensitive(gtk.TRUE)
		self.cpuspinbutton.set_usize(50, 20)
		self.cpuspinbutton.show()

		self.cpuspinlabel=gtk.GtkLabel()
        	self.SOcpuhbox.pack_start(self.cpuspinlabel, gtk.FALSE, gtk.FALSE, 0)
		self.cpuspinlabel.set_text("load")
		self.cpuspinlabel.show()
		
		self.probecheckbutton=gtk.GtkCheckButton("probe IRQs")
		self.SOvbox.pack_start(self.probecheckbutton, gtk.FALSE, gtk.FALSE, 0)
		self.probecheckbutton.set_active(gtk.TRUE)
		self.probecheckbutton.show()

		self.IRQbutton=gtk.GtkButton("Choose IRQs")
		self.SOvbox.pack_start(self.IRQbutton, gtk.FALSE, gtk.FALSE, 0)
		self.IRQbutton.set_sensitive(gtk.FALSE)
		#self.IRQbutton.connect("clicked", self.butcallback, "IRQ button")
		self.IRQbutton.show()

		# Auto-dim frame
		self.ADframe=gtk.GtkFrame()
		self.midhbox.pack_start(self.ADframe, gtk.TRUE, gtk.TRUE, 0)
		self.ADframe.set_shadow_type(gtk.SHADOW_ETCHED_IN)
		self.ADframe.set_label("Auto-dim")
		self.ADframe.show()
		
		# Auto-dim v-scale chooser
		self.bl_adjust=gtk.GtkAdjustment(32, 0, 255, 1, 5, 0)
        	self.bl_adjust.connect("value-changed", self.bl_vscale_changed)
        	self.blvscale=gtk.GtkVScale(self.bl_adjust)
		self.ADframe.add(self.blvscale)
		self.blvscale.show()

		# button hbox on bottom
		self.bothbox=gtk.GtkHBox()
		self.vbox.pack_start(self.bothbox, gtk.TRUE, gtk.TRUE, 0)
		self.bothbox.show()
		
		self.botbuttons=gtk.GtkHButtonBox()
		self.botbuttons.set_spacing(0)
		self.botbuttons.set_child_ipadding_default(0, 0)
		self.botbuttons.set_child_size_default(0,0)
		self.bothbox.pack_start(self.botbuttons, gtk.FALSE, gtk.FALSE, 0)
		
		self.startbutton=gtk.GtkButton("Start")
		self.botbuttons.add(self.startbutton)
		self.startbutton.connect("clicked", self.start_button)
		self.startbutton.show()

		self.stopbutton=gtk.GtkButton("Stop")
		self.botbuttons.add(self.stopbutton)
		self.stopbutton.connect("clicked", self.stop_button)
		self.stopbutton.show()

		self.quitbutton=gtk.GtkButton("Quit")
		self.botbuttons.add(self.quitbutton)
		self.quitbutton.connect("clicked", gtk.mainquit, self.window)
		self.quitbutton.show()
		
		self.botbuttons.show()
		
		self.window.show()

	def quit(self, *args):
		# quit 
		gtk.mainquit()

def main():
	gtk.mainloop()
	
if __name__ == '__main__':
	is_gui = ISgui()
	main()
